/* Create an array from the value of an array */
export const createArray = (array) => {
  let ar =  array.map(el => {
    let newEl = {};
    Object.keys(el).forEach(key => {
      newEl[key] = el[key];
    });
    return newEl;
  });
  
  return ar;
};

/* Compare two arrays by stringify it */
export const compareTwoArrays = (array1, array2) => {
  let newArray1 = createArray(array1);
  newArray1 = deleteKeys(array1, ['o2DatatableRowUuid', 'o2DatatableRowSelected']);
  let newArray2 = createArray(array2);
  newArray2 = deleteKeys(array2, ['o2DatatableRowUuid', 'o2DatatableRowSelected']);
  return JSON.stringify(newArray1) === JSON.stringify(newArray2) ? true : false;
};

/* Delete keys of objects of an array */
export const deleteKeys = (array, keys) => {
  let newArray = array.map(el => {
    let newEl = {};
    Object.keys(el).forEach(key => {
      if(!keys.includes(key)){
        newEl[key] = el[key];        
      }
    });
    return newEl;
  });
  return newArray;
}

/* Set all columns to visible */
export const setColumnsVisible = (columns) => {
  let cols = createArray(columns);
  cols.forEach(col => col.o2DatatableColumnVisible = true);
  return cols;
}

/* Create a column where you can select rows */
export const selectColumn = (columns) => {
  let selectColumn = {
    id: "selectable",
    dataType: "boolean",
    inputType: "checkbox",
    o2DatatableRowSelected: false,
    listName: "",
    width: 50,
    o2DatatableColumnVisible: true,
  }
  
  let alreadyIn = columns.filter(column => selectColumn.id === column.id);
  
  if(alreadyIn.length === 0){
    columns.unshift(selectColumn);
  }
  
  return columns;
}

export const sortColumnsToDisplay = (columns, userColumns) => {
  let ar = [];
  userColumns.forEach(colId => {
    ar.push(columns.find(col => col.id === colId));
  });
  
  return ar;
}